/******************************************************************************/
/* pro2pgsql                                                                  */
/* Copyright (c) 2006, Scott Auge                                             */
/* All rights reserved.                                                       */
/*                                                                            */
/* Redistribution and use in source and binary forms, with or without         */
/* modification, are permitted provided that the following conditions         */
/* are met:                                                                   */
/*                                                                            */
/* * Redistributions of source code must retain the above copyright           */
/*   notice, this list of conditions and the following disclaimer.            */
/* * Redistributions in binary form must reproduce the above copyright        */
/*   notice, this list of conditions and the following disclaimer in          */
/*   the documentation and/or other materials provided with the distribution. */
/* * Neither the name of the Amduus Information Works, Inc. nor the names     */
/*   of its contributors may be used to endorse or promote products derived   */
/*   from this software without specific prior written permission.            */
/*                                                                            */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        */
/* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED  */
/* TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR */
/* PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR           */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,      */
/* EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,        */
/* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR         */
/* PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF     */
/* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING       */
/* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS         */
/* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.               */
/******************************************************************************/

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/pro2pgsql/src/RCS/bat_exportsql.p,v 1.4 2006/07/20 03:07:27 sauge Exp $" NO-UNDO. 

DEFINE VARIABLE cOutputFile AS CHARACTER NO-UNDO.
DEFINE VARIABLE cTable     AS CHARACTER NO-UNDO.
DEFINE VARIABLE cWhere     AS CHARACTER NO-UNDO.
DEFINE VARIABLE cDelete    AS CHARACTER NO-UNDO.
DEFINE VARIABLE cConfigIni AS CHARACTER NO-UNDO.

       
/************************************************************************/
/* This program is meant to be called from a CLI (command line inter-   */
/* face.  See export.bash for more information about using environment  */
/* variables as a means to send parameters to a Progress program.       */
/************************************************************************/

ASSIGN cWhere = OS-GETENV("WHERE")
       cWhere = IF cWhere = ? THEN "" ELSE cWhere
       cDelete = OS-GETENV("DELETE")
       cTable = OS-GETENV("TABLE")
       cOutputFile = OS-GETENV("OUTPUTFILE")
       cConfigIni = OS-GETENV("CONFIGINI").
       
IF cConfigIni = ? THEN ASSIGN cConfigIni = "config.ini".       
       
/************************************************************************/
/* Call into the API that will write out current data in the files of   */
/* the progress table given with the WHERE clause into SQL INSERT state-*/
/* ments.                                                               */
/************************************************************************/

RUN exportsql.p (
 INPUT  cOutputFile,
 INPUT  cTable,
 INPUT  cWhere,
 INPUT  cDelete,
 INPUT  cConfigIni).
 
 
