# Various configurations
# $Id: config.ini,v 1.1 2006/07/28 06:31:14 sauge Exp sauge $

# This is used to map from Progress types to PostgreSQL types

[MapTypes]
CHARACTER=varchar
LOGICAL=boolean
DATE=date
INTEGER=int
# Numeric with no other qualifiers is similar to varchar with no qualifiers
DECIMAL=numeric
# need to look at efficency of float vs numeric in calcs?? is it worth it??
# DECIMAL=float(35)

[Logs]
ErrorLog=/tmp/pro2pgsql_error
ProcessLog=/tmp/pro2pgsql_log

[Transformations]
CleanName=yes
Encoding=LATIN1

# OutputSQL = yes - outputs a file with SQL insert statements (the default)
# OutputSQL = no  - outputs a csv file.

OutputSQL=yes

[ArrayConversion]
# Converting arrays
# a) Type=Array       - outputs progress array's as postgres array's (the Default)
# b) Type=SingleField - outputs each extent of the progress array as a single field with the name of the field suffixed with the extent number


# Type=Array
Type=SingleField

[DateConversion]
# Converting Dates - Handling Null Dates
# ConvertNull=no      - When the date is null, don't convert it (the default)
# ConvertNull=yes     - Convert the date to the string found in the NullDate variable
# NullDate=NULL       - Output the string NULL. Should not be quoted and can be used in both SQL and CSV data loads. Loads the null value to the field.
# NullDate=DEFAULT    - Output the string DEFAULT. Should not be quoted and can be used in both SQL and CSV data loads. loads the default value as defined in the table definition.
# NullDate=1900-01-01 - Output the string 1900-01-01. Should be quoted and can be used in both SQL and CSV data loads. loads the value 01/01/1900 to the field. can use any date as long as it is in YYYY-MM-DD format
# NullDate=epoch      - Output the string epoch. Should be quoted and can be used in both SQL and CSV data loads. loads the value 01/01/1970 to the field.
# NullDate=           - Output no string. output a blank. can be quoted or unquoted and can be used in both SQL and CSV data loads
# QuoteNullDate=no    - leave the NullDate value as is, ie unquoted
# QuoteNullDate=yes   - put quotes around the NullDate value. for CSV files this is defined by the Quote variable

#ConvertNull=no
ConvertNull=yes

NullDate=NULL
# NullDate=DEFAULT
#NullDate=##
QuoteNullDate=no

# NullDate=1900-01-01
# NullDate=epoch
# NullDate=
# QuoteNullDate=yes

[CSVConfig]
# variables for CSV files only
# refer to copy command in postgres Manual

# Header=no
Header=yes

# Delimiter=\t
# Delimiter=|
Delimiter=,

# Null=NULL
# Null=DEFAULT
Null=

# see 4.1.2.2. Dollar-Quoted String Constants in Postgres manual
# Quote=$$
# Quote=$SomeTag$
# Escape=

# see 4.1.2.1. String Constants in Postgres manual
Quote="
Escape="
# Escape=\

# Quote='
# Escape=\
# Escape='


# todo - how to better handle null fields eg. NULL, DEFAULT etc
# todo - for delimiters allow \t or ~t to represent a tab character and possibly \xxx to represent a decimal or octal character
# todo - only doing inserts on non-null fields
# todo - look at infinity, -infinity and NaN as defaults in schema creation as they don't seem to be valid inputs in SQL or CSV data loads




