/******************************************************************************/
/* pro2pgsql                                                                  */
/* Copyright (c) 2006, Scott Auge                                             */
/* All rights reserved.                                                       */
/*                                                                            */
/* Redistribution and use in source and binary forms, with or without         */
/* modification, are permitted provided that the following conditions         */
/* are met:                                                                   */
/*                                                                            */
/* * Redistributions of source code must retain the above copyright           */
/*   notice, this list of conditions and the following disclaimer.            */
/* * Redistributions in binary form must reproduce the above copyright        */
/*   notice, this list of conditions and the following disclaimer in          */
/*   the documentation and/or other materials provided with the distribution. */
/* * Neither the name of the Amduus Information Works, Inc. nor the names     */
/*   of its contributors may be used to endorse or promote products derived   */
/*   from this software without specific prior written permission.            */
/*                                                                            */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS        */
/* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED  */
/* TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR */
/* PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR           */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,      */
/* EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,        */
/* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR         */
/* PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF     */
/* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING       */
/* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS         */
/* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.               */
/******************************************************************************/

                                                                                 


  /**************************************************************************/
  /*                              PLEASE READ                               */
  /*                                ______                                  */
  /*                             .-"      "-.                               */
  /*                            /            \                              */
  /*                _          |              |          _                  */
  /*               ( \         |,  .-.  .-.  ,|         / )                 */
  /*                > "=._     | )(__/  \__)( |     _.=" <                  */
  /*               (_/"=._"=._ |/     /\     \| _.="_.="\_)                 */
  /*                      "=._ (_     ^^     _)"_.="                        */
  /*                          "=\__|IIIIII|__/="                            */
  /*                         _.="| \IIIIII/ |"=._                           */
  /*               _     _.="_.="\          /"=._"=._     _                 */
  /*              ( \_.="_.="     `--------`     "=._"=._/ )                */                           
  /*               > _.="  DO NOT EDIT FRIVOLOUSLY!  "=._ <                 */
  /*              (_/                                    \_)                */
  /*                                                                        */
  /*        THIS PROGRAM WILL BE SPLIT INTO  TWO DIFFERENT PROGRAMS         */
  /*        IN THE NEAR FUTURE.  ONE WILL BE EXPORTSQL.P SOLELY FOR         */
  /*        SQL AND  THE OTHER  WILL BE  EXPORTCSV.P SOLELY FOR CSV         */
  /*        EXPORTING.  IF  YOU WANT TO  ADD S OMETHING - SPLIT THE         */
  /*        PROGRAMS FIRST! THANKS!                                         */
  /**************************************************************************/       
                                                                                  
  
  
  
  

DEFINE VARIABLE RCS AS CHARACTER INIT "$Header: /home/appl/pro2pgsql/src/RCS/exportsql.p,v 1.6 2006/07/28 06:43:19 sauge Exp sauge $" NO-UNDO.

&GLOBAL-DEFINE WRT PUT UNFORMATTED
&GLOBAL-DEFINE LOG PUT STREAM LogStream UNFORMATTED

DEFINE INPUT PARAMETER cOutputFile AS CHARACTER NO-UNDO.                               
DEFINE INPUT PARAMETER cTable      AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER cWhere      AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER cDelete     AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER cConfigIni  AS CHARACTER NO-UNDO.

DEFINE VARIABLE cFieldList     AS CHARACTER NO-UNDO.
DEFINE VARIABLE cQuery         AS CHARACTER NO-UNDO.

DEFINE VARIABLE hBuffer        AS HANDLE NO-UNDO.
DEFINE VARIABLE hField         AS HANDLE NO-UNDO.
DEFINE VARIABLE hQuery         AS HANDLE NO-UNDO.

DEFINE VARIABLE iNumFields     AS INTEGER NO-UNDO.
DEFINE VARIABLE iNumExts       AS INTEGER NO-UNDO.
DEFINE VARIABLE iCurField      AS INTEGER NO-UNDO.
DEFINE VARIABLE cCurField      AS CHARACTER NO-UNDO.

DEFINE VARIABLE i              AS INTEGER NO-UNDO.

DEFINE VARIABLE cSQL           AS CHARACTER NO-UNDO.
DEFINE VARIABLE iCurExt        AS INTEGER NO-UNDO.

DEFINE VARIABLE cOutputSQL     AS CHARACTER NO-UNDO.
DEFINE VARIABLE cDelimiter     AS CHARACTER NO-UNDO.
DEFINE VARIABLE cNull          AS CHARACTER NO-UNDO.
DEFINE VARIABLE cQuote         AS CHARACTER NO-UNDO.
DEFINE VARIABLE cEscape        AS CHARACTER NO-UNDO.
DEFINE VARIABLE cHeader        AS CHARACTER NO-UNDO.
DEFINE VARIABLE cConvDate      AS CHARACTER NO-UNDO.
DEFINE VARIABLE cNullDate      AS CHARACTER NO-UNDO.
DEFINE VARIABLE cQuoteNullDate AS CHARACTER NO-UNDO.
DEFINE VARIABLE cArrayType     AS CHARACTER NO-UNDO.

DEFINE VARIABLE cFmt           AS CHARACTER NO-UNDO.

{tblOperationalParameters.i}

DEFINE STREAM LogStream.
DEFINE STREAM ErrStream.

/************************************************************************/
/* Convenient instead of littering code with OperationParameters finds  */
/************************************************************************/

FUNCTION FindParam RETURNS CHARACTER
    (INPUT cSection AS CHARACTER,
     INPUT cName AS CHARACTER):

  FIND OperationalParameters NO-LOCK
  WHERE OperationalParameters.PSection = cSection
    AND OperationalParameters.PName = cName
  NO-ERROR.                                                                              

  IF AVAILABLE OperationalParameters THEN RETURN OperationalParameters.PValue.

END. /* FUNCTION FindParams */

{cleanname.i}

/************************************************************************/
/* Progress dates are different than pgsql dates.  Conversion here.     */
/************************************************************************/

FUNCTION mdy2SQLDate RETURNS CHARACTER (INPUT dDate AS DATE):

  RETURN STRING(YEAR(dDate)) + "-"
        + STRING(MONTH(dDate)) + "-"
    + STRING(DAY(dDate)).

END.

/************************************************************************/
/* For SQL statements, sometimes we need to escape certain characters   */
/* in the data.                                                         */
/************************************************************************/

FUNCTION EscapeStrings RETURNS CHARACTER (INPUT cString AS CHARACTER):

  DEFINE VARIABLE cEsc AS CHARACTER NO-UNDO.

  ASSIGN cEsc = REPLACE (cString, "\\", "\\\\")
         cEsc = REPLACE (cEsc, "'", "\\'").

  RETURN cEsc.
  
END.

/***************************************************************************************************/
/* Function to conver the raw field into something the INSERT SQL or COPY commands will understand */
/***************************************************************************************************/

FUNCTION fConvField RETURNS CHARACTER (INPUT hField         AS HANDLE,
                                       INPUT cDataType      AS CHARACTER, /* hField:DATA-TYPE */
                                       INPUT iCurExt        AS INTEGER,   /* if there are no extents then the field value can be referenced by 0 */
                                       INPUT cDelimiter     AS CHARACTER,
                                       INPUT cNull          AS CHARACTER,
                                       INPUT cQuote         AS CHARACTER,
                                       INPUT cEscape        AS CHARACTER,
                                       INPUT cConvDate      AS CHARACTER,
                                       INPUT cNullDate      AS CHARACTER,
                                       INPUT cQuoteNullDate AS CHARACTER
                                      ).

  DEFINE VARIABLE cSQL       AS CHARACTER NO-UNDO.

  ASSIGN cSQL = "".

  CASE cDataType:
  
    WHEN "DATE" THEN
      IF hField:BUFFER-VALUE(iCurExt) = ? THEN
        IF cConvDate = "yes" THEN
          ASSIGN cSQL = cSQL + (if cQuoteNullDate = "yes" then cQuote else "") + cNullDate + (if cQuoteNullDate = "yes" then cQuote else "") + cDelimiter.
        ELSE
          /* ASSIGN cSQL = cSQL + cQuote + mdy2SQLDate(DATE(hField:BUFFER-VALUE(iCurExt))) + cQuote + cDelimiter. */
          ASSIGN cSQL = cSQL + cQuote + cQuote + cDelimiter.
      ELSE
        ASSIGN cSQL = cSQL + cQuote +
                      mdy2SQLDate(DATE(INTEGER(hField:BUFFER-VALUE(iCurExt)))) +
                      cQuote + cDelimiter.
  
    WHEN "LOGICAL" THEN
      ASSIGN cSQL = cSQL + cQuote +
                    (IF INTEGER(hField:BUFFER-VALUE(iCurExt)) = 1 /*TRUE*/ THEN "yes" ELSE "no") +
                    cQuote + cDelimiter.
  
    WHEN "CHARACTER" THEN
      ASSIGN cSQL = cSQL + cQuote +
                    REPLACE(REPLACE(STRING(hField:BUFFER-VALUE(iCurExt)), cQuote, (cEscape + cQuote)), "\\", "\\\\") +
                    cQuote + cDelimiter.
  
    WHEN "DECIMAL" OR WHEN "INTEGER" THEN
      ASSIGN cSQL = cSQL + REPLACE(STRING(DECIMAL(hField:BUFFER-VALUE(iCurExt))), ",", "") + cDelimiter.
  
    OTHERWISE
      ASSIGN cSQL = cSQL + STRING(hField:BUFFER-VALUE(iCurExt)) + cDelimiter.
  
  END. /* CASE */

  RETURN cSQL.
END FUNCTION.


/************************************************************************/
/* Walk the ini to find out operational parameters                      */
/************************************************************************/

IF cConfigIni = ? then cConfigIni = "config.ini".
RUN inisetbytt.p (INPUT SEARCH(cConfigIni),
                  INPUT "",
          OUTPUT TABLE OperationalParameters APPEND).

/************************************************************************/
/* Initialise variables with operational parameters from ini file       */
/************************************************************************/

ASSIGN cOutputSQL     = FindParam("Transformations", "OutputSQL").
ASSIGN cArrayType     = FindParam("ArrayConversion", "Type").
ASSIGN cConvDate      = FindParam("DateConversion", "ConvertNull").
ASSIGN cNullDate      = FindParam("DateConversion", "NullDate").
ASSIGN cQuoteNullDate = FindParam("DateConversion", "QuoteNullDate").
ASSIGN cDelimiter     = FindParam("CSVConfig", "Delimiter").
ASSIGN cNull          = FindParam("CSVConfig", "Null").
ASSIGN cQuote         = FindParam("CSVConfig", "Quote").
ASSIGN cEscape        = FindParam("CSVConfig", "Escape").
ASSIGN cHeader        = FindParam("CSVConfig", "Header").

/* if not entered in the ini file, default to ...                            */
IF cOutputSQL     = ?  THEN ASSIGN cOutputSQL     = "yes".   /* yes          */
IF cArrayType     = ?  THEN ASSIGN cArrayType     = "Array". /* Array        */
IF cConvDate      = ?  THEN ASSIGN cConvDate      = "no".    /* no           */
IF cNullDate      = ?  THEN ASSIGN cNullDate      = "".      /* blank        */
IF cQuoteNullDate = ?  THEN ASSIGN cQuoteNullDate = "yes".   /* yes          */
IF cDelimiter     = ?  THEN ASSIGN cDelimiter     = ",".     /* comma        */
IF cNull          = ?  THEN ASSIGN cNull          = "".      /* blank        */
IF cQuote         = ?  THEN ASSIGN cQuote         = "'".     /* single quote */
IF cEscape        = ?  THEN ASSIGN cEscape        = "'".     /* single quote */
IF cHeader        = ?  THEN ASSIGN cHeader        = "no".    /* no           */

/* if we are not producing a CSV file then set all defaults for SQL output   */
IF cOutputSQL  <> "no" THEN
  ASSIGN cDelimiter     = ","     /* default to comma                        */
         cQuote         = "'"     /* default to single quote                 */
         cEscape        = cQuote. /* default to single quote                 */

/* Note: where possible all logical references to ini file parameters are  */
/* in the "negative". This is deliberate to ensure that the default action */
/* occurs.                                                                 */

/************************************************************************/
/* Start our logging.                                                   */
/************************************************************************/

OUTPUT STREAM ErrStream TO VALUE(FindParam("Logs", "ErrorLog")) APPEND.
OUTPUT STREAM LogStream TO VALUE(FindParam("Logs", "ProcessLog")) APPEND.

{&LOG} "*********** " STRING(TODAY) " " STRING (TIME, "HH:MM:SS") "**********" SKIP.

{&LOG} "Working with parameters:" SKIP.
FOR EACH OperationalParameters:

  {&LOG} OperationalParameters.PSection SPACE(1)
         OperationalParameters.PName  SPACE(1)
     OperationalParameters.PValue
     SKIP.

END. /* FOR EACH OperationalParameters */

/************************************************************************/
/* Walk the command line to find our operational parameters.            */
/* We do this in case some are overwritten from those in the config.ini */
/************************************************************************/


{&LOG} "Output file is " cOutputFile SKIP.
{&LOG} "Table is " CleanName(cTable) SKIP.
{&LOG} "Where is " cWhere SKIP.
{&LOG} "Delete is " cDelete SKIP.

/************************************************************************/
/* Begin processing                                                     */
/************************************************************************/

OUTPUT TO VALUE(cOutputFile).

CREATE BUFFER hBuffer FOR TABLE cTable.
CREATE QUERY hQuery.
hQuery:ADD-BUFFER(hBuffer).

ASSIGN cQuery = "FOR EACH " + CleanName(cTable) + " NO-LOCK " + cWhere.

{&LOG} "cQuery is " cQuery SKIP.

IF hQuery:QUERY-PREPARE(cQuery) = FALSE THEN DO:

  {&LOG} "Query failed to prepare: " cQuery SKIP.

  QUIT.

END.


IF hQuery:QUERY-OPEN() = FALSE THEN DO:

  {&WRT} "Open FAILED!" SKIP.

  /* Begin Used for debugging */

  REPEAT i = 1 TO hQuery:NUM-BUFFERS:
    hBuffer = hQuery:GET-BUFFER-HANDLE(i).
    {&WRT} "Query Has Buffer: " + hBuffer:NAME SKIP.
  END.

  QUIT.

END. /* IF lStatusFlag = FALSE */

ASSIGN iNumFields = hBuffer:NUM-FIELDS.

{&LOG} "Number of fields on " CleanName(cTable) " is " iNumFields SKIP.

/************************************************************************/
/* If we have a delete flag set to yes, then issue a delete of all rec- */
/* ords in that table before the insertions. Only for SQL output.       */
/************************************************************************/

IF cDelete = "yes" AND cOutputSQL <> "no" THEN
    {&WRT} "DELETE FROM " CleanName(cTable) ";" SKIP.

/************************************************************************/
/* Begin constructing the SQL, or CSV data to be thrown into the table. */
/************************************************************************/

REPEAT :
  IF cOutputSQL = "no" THEN
  /**********************************************************/  
  /* If we are doing CSV as the output, clear the data line */
  /**********************************************************/  
    ASSIGN cSQL = "".
  ELSE
  /**********************************************************/  
  /* If we are doing SQL as the output, we start the INSERT */
  /**********************************************************/  
    ASSIGN cSQL = "INSERT INTO " + CleanName(cTable) + " (".

  hQuery:GET-NEXT.
  IF (hQuery:QUERY-OFF-END) THEN LEAVE.

  hBuffer = hQuery:GET-BUFFER-HANDLE(1).

  /*********************************************************************/  
  /* If we are doing SQL as the output, write out the column Names     */
  /* If we are doing CSV as the output and we need a header, write out */
  /* the column Names enclosed in quotes                               */
  /*********************************************************************/  
  IF cOutputSQL <> "no" OR cHeader = "yes" THEN
  DO:
    cHeader = "no".
    DO iCurField = 1 TO iNumFields:

      ASSIGN hField = hBuffer:BUFFER-FIELD(iCurField).
      IF hField:EXTENT = 0 OR cArrayType = "Array" THEN
        ASSIGN cSQL = cSQL + (if cOutputSQL <> "no" then "" else cQuote) +
                      CleanName(hField:NAME) +
                      (if cOutputSQL <> "no" then "" else cQuote) + ",".
      ELSE
      DO:
        /**********************************************************/
        /* How many digits will we need in the format.            */
        /* and write out the names.                               */
        /**********************************************************/
        ASSIGN cFmt = "".
        DO i = 1 TO LENGTH(STRING(hField:EXTENT)):
          ASSIGN cFmt = cFmt + "9".
        END. /* DO i */
        DO iCurExt = 1 TO hField:EXTENT:
          /* quotes added around names only if CSV header */
          ASSIGN cSQL = cSQL + (if cOutputSQL <> "no" then "" else cQuote) +
                        CleanName(hField:NAME) + "_" + STRING(iCurExt, cFmt) +
                        (if cOutputSQL <> "no" then "" else cQuote) + ",".
        END. /* DO iCurExt */

      END. /* ELSE */

    END.  /* DO iCurField */

    ASSIGN cSQL = SUBSTRING(cSQL, 1, LENGTH(cSQL) - 1).
    IF cOutputSQL <> "no" THEN
      /* Start on SQL values */
      ASSIGN cSQL = cSQL + ") VALUES (".
    ELSE
      /* finish off CSV header line */
      ASSIGN cSQL = cSQL + "~n".

  END. /* IF */

  DO iCurField = 1 TO iNumFields:

    ASSIGN hField = hBuffer:BUFFER-FIELD(iCurField).

    /**********************************************************/
    /* Determine if we are working with an array or not.      */
    /* First block is handling non-arrayed fields.            */
    /**********************************************************/

    IF hField:EXTENT = 0 THEN DO:

      ASSIGN cSQL = cSQL + fConvField(hField        ,
                                    hField:DATA-TYPE,
                                    0               ,
                                    cDelimiter      ,
                                    cNull           ,
                                    cQuote          ,
                                    cEscape         ,
                                    cConvDate       ,
                                    cNullDate       ,
                                    cQuoteNullDate
                                   ).

    END. /* IF hField:EXTENT = 0 */

    /**********************************************************/
    /* Handle arrayed fields here.                            */
    /**********************************************************/

    ELSE DO:

      CASE cArrayType:
        WHEN "Array" THEN
        DO:
          ASSIGN cSQL = cSQL + "\'\{".
          DO iCurExt = 1 TO hField:EXTENT:
            ASSIGN cSQL = cSQL + fConvField(hField        ,
                                          hField:DATA-TYPE,
                                          iCurExt         ,
                                          ","             ,
                                          ""              ,
                                          """"            ,
                                          """"            ,
                                          cConvDate       ,
                                          cNullDate       ,
                                          cQuoteNullDate
                                         ).

          END.  /* DO iCurExt */
          ASSIGN cSQL = SUBSTRING(cSQL, 1, LENGTH(cSQL) - 1 ).
          ASSIGN cSQL = cSQL + "\}\'" + ",".
        END. /* WHEN Array */

        WHEN "SingleField" THEN
        DO:
          DO iCurExt = 1 TO hField:EXTENT:
            ASSIGN cSQL = cSQL + fConvField(hField        ,
                                          hField:DATA-TYPE,
                                          iCurExt         ,
                                          cDelimiter      ,
                                          cNull           ,
                                          cQuote          ,
                                          cEscape         ,
                                          cConvDate       ,
                                          cNullDate       ,
                                          cQuoteNullDate
                                         ).

          END.  /* DO iCurExt */
        END. /* WHEN SingleField */

        OTHERWISE
        DO:
          {&LOG} "ERRROR!!!  Invalid Array Conversion Type:" + cArrayType +
                 " - Must be Either 'Array' or 'SingleField' " SKIP.

          ASSIGN cSQL = cSQL + "\'\{\}\'" + ",".
        END. /* OTHERWISE */
      END. /* CASE */
    END. /* Multi-extent fields */

  END.  /* DO iCurField */

  ASSIGN cSQL = SUBSTRING(cSQL, 1, LENGTH(cSQL) - (IF cOutputSQL <> "no" THEN 1 ELSE LENGTH(cDelimiter))).
  IF cOutputSQL <> "no" THEN
    ASSIGN cSQL = cSQL + ");".

  IF cSQL <> ? THEN {&WRT} cSQL SKIP.


END. /* REPEAT */

/************************************************************************/
/* Housekeeping.                                                        */
/************************************************************************/

{&LOG} "Done!" SKIP.

OUTPUT CLOSE.
OUTPUT STREAM ErrStream CLOSE.
OUTPUT STREAM LogStream CLOSE.

DELETE OBJECT hBuffer.
DELETE OBJECT hQuery.

QUIT.

/*------------------------ Internal Procedures -------------------------*/


